package me.mrletsplay.nojs.component.impl;

import me.mrletsplay.nojs.component.Component;
import me.mrletsplay.simplehttpserver.dom.html.HtmlElement;

public class Text implements Component {

	private Type type;
	private String text;

	public Text() {
		this.type = Type.PLAIN;
		this.text = "Text";
	}

	public Text type(Type type) {
		this.type = type == null ? Type.PLAIN : type;
		return this;
	}

	public Text text(String text) {
		this.text = text != null ? text : "Text";
		return this;
	}

	@Override
	public HtmlElement toHtml() {
		HtmlElement text = HtmlElement.of(type == Type.PLAIN ? "span" : "p");
		text.addClass("text");
		text.setText(this.text);
		return text;
	}

	public static enum Type {

		PLAIN,
		PARAGRAPH,
		;

	}

}
