package me.mrletsplay.nojs.page.layout;

import me.mrletsplay.simplehttpserver.dom.html.HtmlElement;

public class HClampLayout implements Layout {

	private String
		min,
		preferred,
		max;

	private HAlignment hAlignment;

	public HClampLayout(String min, String preferred, String max) {
		this.min = min == null ? "0" : min;
		this.preferred = preferred == null ? "100%" : preferred;
		this.max = max == null ? "100%" : max;
		this.hAlignment = HAlignment.NORMAL;
	}

	public HClampLayout hAlignment(HAlignment hAlignment) {
		this.hAlignment = hAlignment != null ? hAlignment : HAlignment.NORMAL;
		return this;
	}

	@Override
	public void apply(HtmlElement html) {
		String css = "display:grid;";

		css += "grid-template-columns:clamp(" + min + "," + preferred + "," + max + ");";

		if(hAlignment != HAlignment.NORMAL) {
			css += "justify-content:" + hAlignment.name().toLowerCase() + ";";
		}

		html.appendAttribute("style", css);
	}

	public static enum HAlignment {

		NORMAL,
		START,
		CENTER,
		END,
		STRETCH,
		;

	}

}
